{
    "scan": {
        "analyzer-version-clang": "18.1.2",
        "analyzer-version-cppcheck": "2.13.0",
        "analyzer-version-gcc": "14.0.1",
        "analyzer-version-gcc-analyzer": "14.0.1",
        "analyzer-version-shellcheck": "0.10.0",
        "enabled-plugins": "clang, cppcheck, gcc, shellcheck",
        "exit-code": 0,
        "host": "ip-172-16-1-17.us-west-2.compute.internal",
        "mock-config": "fedora-41-x86_64",
        "project-name": "libassuan-2.5.7-1.fc41",
        "store-results-to": "/tmp/tmpi71mj_y1/libassuan-2.5.7-1.fc41.tar.xz",
        "time-created": "2024-04-17 06:11:06",
        "time-finished": "2024-04-17 06:12:07",
        "tool": "csmock",
        "tool-args": "'/usr/bin/csmock' '-r' 'fedora-41-x86_64' '-t' 'shellcheck,clang,cppcheck,gcc' '-o' '/tmp/tmpi71mj_y1/libassuan-2.5.7-1.fc41.tar.xz' '--gcc-analyze' '/tmp/tmpi71mj_y1/libassuan-2.5.7-1.fc41.src.rpm'",
        "tool-version": "csmock-3.5.3-1.el9"
    },
    "defects": [
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 563,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/libassuan-config",
                    "line": 27,
                    "column": 1,
                    "event": "warning[SC2034]",
                    "message": "exec_prefix_set appears unused. Verify use (or export if used externally).",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   25|   includes=\"\"",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   26|   libdirs=\"\"",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   27|-> exec_prefix_set=no",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   28|   echo_libs=no",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   29|   echo_cflags=no",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 563,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/bin/libassuan-config",
                    "line": 57,
                    "column": 6,
                    "event": "warning[SC2034]",
                    "message": "optarg appears unused. Verify use (or export if used externally).",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   55|     case \"$1\" in",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   56|     -*=*) optarg=`echo \"$1\" | sed 's/[-_a-zA-Z0-9]*=//'` ;;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   57|->   *) optarg= ;;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   58|     esac",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   59|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libassuan-2.5.7/src/assuan-socket-connect.c",
                    "line": 242,
                    "event": "error[nullPointer]",
                    "message": "Null pointer dereference: (struct sockaddr_un*)0",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  240|           return _assuan_error (ctx, gpg_err_code_from_syserror ());",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  241|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  242|->       len = SUN_LEN (&srvr_addr_un);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  243|         srvr_addr = (struct sockaddr *)&srvr_addr_un;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  244|       }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libassuan-2.5.7/src/assuan-socket.c",
                    "line": 1081,
                    "event": "error[nullPointer]",
                    "message": "Null pointer dereference: (struct sockaddr_un*)0",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1079|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1080|                 res = _assuan_connect (ctx, sockfd, (struct sockaddr *)unaddr,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1081|->                                      SUN_LEN (unaddr));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1082|                 free (unaddr);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1083|                 return res;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function '__assuan_spawn'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 14,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor 'dup2(<unknown>, 1)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 279,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'pid >= 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'pid == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 291,
                    "column": 10,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 303,
                    "column": 10,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 303,
                    "column": 10,
                    "event": "note",
                    "message": "(7) following 'true' branch (when 'fd_out != 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 15,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 15,
                    "event": "note",
                    "message": "(9) following 'true' branch (when 'fd_out == -1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 15,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 15,
                    "event": "note",
                    "message": "(11) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 14,
                    "event": "note",
                    "message": "(12) 'dup2(<unknown>, 1)' leaks here; was opened at (11)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  303|         if (fd_out != STDOUT_FILENO)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  304|   \t{",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  305|-> \t  if (dup2 (fd_out == ASSUAN_INVALID_FD ? fdnul : fd_out,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  306|   \t\t    STDOUT_FILENO) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  307|   \t    {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 14,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor 'open(\"/dev/null\", 1)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 279,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'pid >= 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'pid == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 291,
                    "column": 10,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 294,
                    "column": 15,
                    "event": "note",
                    "message": "(5) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(6) assuming 'open(\"/dev/null\", 1)' is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(7) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 303,
                    "column": 10,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 303,
                    "column": 10,
                    "event": "note",
                    "message": "(9) following 'true' branch (when 'fd_out != 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 15,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 15,
                    "event": "note",
                    "message": "(11) following 'true' branch (when 'fd_out == -1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 15,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 305,
                    "column": 14,
                    "event": "note",
                    "message": "(13) 'open(\"/dev/null\", 1)' leaks here; was opened at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  303|         if (fd_out != STDOUT_FILENO)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  304|   \t{",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  305|-> \t  if (dup2 (fd_out == ASSUAN_INVALID_FD ? fdnul : fd_out,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  306|   \t\t    STDOUT_FILENO) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  307|   \t    {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 14,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor 'dup2(<unknown>, 0)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 279,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'pid >= 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'pid == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 291,
                    "column": 10,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 303,
                    "column": 10,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 314,
                    "column": 10,
                    "event": "note",
                    "message": "(7) following 'true' branch (when 'fd_in != 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 15,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 15,
                    "event": "note",
                    "message": "(9) following 'true' branch (when 'fd_in == -1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 15,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 15,
                    "event": "note",
                    "message": "(11) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 14,
                    "event": "note",
                    "message": "(12) 'dup2(<unknown>, 0)' leaks here; was opened at (11)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  314|         if (fd_in != STDIN_FILENO)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  315|   \t{",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  316|-> \t  if (dup2 (fd_in == ASSUAN_INVALID_FD ? fdnul : fd_in,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  317|   \t\t    STDIN_FILENO) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  318|   \t    {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 14,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor 'open(\"/dev/null\", 1)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 279,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'pid >= 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'pid == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 291,
                    "column": 10,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 294,
                    "column": 15,
                    "event": "note",
                    "message": "(5) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(6) assuming 'open(\"/dev/null\", 1)' is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(7) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 303,
                    "column": 10,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 314,
                    "column": 10,
                    "event": "note",
                    "message": "(9) following 'true' branch (when 'fd_in != 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 15,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 15,
                    "event": "note",
                    "message": "(11) following 'true' branch (when 'fd_in == -1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 15,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 316,
                    "column": 14,
                    "event": "note",
                    "message": "(13) 'open(\"/dev/null\", 1)' leaks here; was opened at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  314|         if (fd_in != STDIN_FILENO)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  315|   \t{",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  316|-> \t  if (dup2 (fd_in == ASSUAN_INVALID_FD ? fdnul : fd_in,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  317|   \t\t    STDIN_FILENO) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  318|   \t    {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 335,
                    "column": 14,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor 'dup2(open(\"/dev/null\", 1), 2)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 279,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'pid >= 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'pid == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 291,
                    "column": 10,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 303,
                    "column": 10,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 335,
                    "column": 15,
                    "event": "note",
                    "message": "(7) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 335,
                    "column": 14,
                    "event": "note",
                    "message": "(8) 'dup2(open(\"/dev/null\", 1), 2)' leaks here; was opened at (7)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  333|         if (!fdp || *fdp == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  334|   \t{",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  335|-> \t  if (dup2 (fdnul, STDERR_FILENO) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  336|   \t    {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  337|   \t      TRACE1 (ctx, ASSUAN_LOG_SYSIO, \"pipe_connect_unix\", ctx,",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 335,
                    "column": 14,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor 'open(\"/dev/null\", 1)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 279,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'pid >= 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 282,
                    "column": 6,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'pid == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 291,
                    "column": 10,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 294,
                    "column": 15,
                    "event": "note",
                    "message": "(5) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(6) assuming 'open(\"/dev/null\", 1)' is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(7) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 303,
                    "column": 10,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/src/system-posix.c",
                    "line": 335,
                    "column": 14,
                    "event": "note",
                    "message": "(9) 'open(\"/dev/null\", 1)' leaks here; was opened at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  333|         if (!fdp || *fdp == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  334|   \t{",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  335|-> \t  if (dup2 (fdnul, STDERR_FILENO) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  336|   \t    {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  337|   \t      TRACE1 (ctx, ASSUAN_LOG_SYSIO, \"pipe_connect_unix\", ctx,",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 2,
            "events": [
                {
                    "file_name": "libassuan-2.5.7/tests/fdpassing.c",
                    "line": 34,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘main’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 202,
                    "column": 7,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘prepend_srcdir(\"motd\")’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libassuan-2.5.7/tests/fdpassing.c",
                    "line": 217,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/fdpassing.c",
                    "line": 226,
                    "column": 17,
                    "event": "note",
                    "message": "(2) calling ‘prepend_srcdir’ from ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 197,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to ‘prepend_srcdir’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 202,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 202,
                    "column": 29,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 205,
                    "column": 12,
                    "event": "note",
                    "message": "(6) calling ‘xmalloc’ from ‘prepend_srcdir’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 60,
                    "column": 1,
                    "event": "note",
                    "message": "(7) entry to ‘xmalloc’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 62,
                    "column": 13,
                    "event": "note",
                    "message": "(8) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 63,
                    "column": 6,
                    "event": "note",
                    "message": "(9) assuming ‘p’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 63,
                    "column": 6,
                    "event": "note",
                    "message": "(10) following ‘false’ branch (when ‘p’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 70,
                    "column": 10,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 205,
                    "column": 12,
                    "event": "note",
                    "message": "(12) returning to ‘prepend_srcdir’ from ‘xmalloc’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/fdpassing.c",
                    "line": 226,
                    "column": 17,
                    "event": "note",
                    "message": "(13) returning to ‘main’ from ‘prepend_srcdir’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/fdpassing.c",
                    "line": 228,
                    "column": 6,
                    "event": "note",
                    "message": "(14) following ‘true’ branch (when ‘argc != 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/fdpassing.c",
                    "line": 230,
                    "column": 7,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/fdpassing.c",
                    "line": 233,
                    "column": 15,
                    "event": "note",
                    "message": "(16) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/fdpassing.c",
                    "line": 236,
                    "column": 12,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libassuan-2.5.7/tests/common.h",
                    "line": 202,
                    "column": 7,
                    "event": "note",
                    "message": "(18) ‘prepend_srcdir(\"motd\")’ leaks here; was allocated at (8)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  200|     char *result;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  201|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  202|->   if (!srcdir && !(srcdir = getenv (\"srcdir\")))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  203|       srcdir = \".\";",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  204|     ",
                    "verbosity_level": 1
                }
            ]
        }
    ]
}
